
#include <stdio.h>


main(argc,argv)

int		argc;
char		*argv[];

{
int		i,NRows,NCols,*x,*y,TP,w,D,nw,PM,iter,skippage;
unsigned char	*EMI,*EDI;
float		ew[5];
FILE		*fpt;
char		OutputFilename[100];

if (argc == 1)
  {
  PrintHelp();
  exit();
  }
ParseArguments(argc,argv,&EMI,&EDI,&NRows,&NCols,&x,&y,&TP,
	&w,ew,&D,&nw,&iter,&skippage,OutputFilename);
if ((fpt=fopen(OutputFilename,"w")) == NULL)
  {
  fprintf(stdout,"Couldn't open %s for writing.\n",OutputFilename);
  exit();
  }
for (i=0; i<iter; i++)
  {
  MoveContour(EMI,EDI,NRows,NCols,x,y,TP,w,ew,D,nw,&PM);
  fprintf(stdout,"%d points moved during iteration %d\n",PM,i);
  if (PM == 0)
    break;
  }
fprintf(stdout,"Completed\n");
fprintf(fpt,"%d\n",TP);
for (i=0; i<TP; i++)
  fprintf(fpt,"%d %d\n",x[i],y[i]);
fclose(fpt);
}



ParseArguments(argc,argv,EMI,EDI,NRows,NCols,x,y,TP,w,ew,D,nw,
	iter,skippage,outfile)

int		argc,*NRows,*NCols,**x,**y,*TP,*w,*D,*nw,*iter,*skippage;
unsigned char	**EMI,**EDI;
float		ew[5];
char		*argv[],outfile[];

{
char		EMIFilename[100],EDIFilename[100],ContourFilename[100];
int		i;
double		atof();

strcpy(EMIFilename,"");
strcpy(EDIFilename,"");
strcpy(ContourFilename,"");
strcpy(outfile,"snakes.out");
*NRows=*NCols=0;
*w=2;
*D=0;
*nw=0;
*iter=10;
*skippage=1;
ew[0]=1.2;
ew[1]=0.0;
ew[2]=1.0;
ew[3]=1.0;
ew[4]=0.0;

for (i=1; i<argc; i=i+2)
  {
  if ((strcmp(argv[i],"-emi")) == 0)
    strcpy(EMIFilename,argv[i+1]);
  else if ((strcmp(argv[i],"-edi")) == 0)
    strcpy(EDIFilename,argv[i+1]);
  else if ((strcmp(argv[i],"-o")) == 0)
    strcpy(outfile,argv[i+1]);
  else if ((strcmp(argv[i],"-x")) == 0)
    *NCols=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-y")) == 0)
    *NRows=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-c")) == 0)
    strcpy(ContourFilename,argv[i+1]);
  else if ((strcmp(argv[i],"-ws")) == 0)
    *w=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-nws")) == 0)
    *nw=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-dir")) == 0)
    *D=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-iter")) == 0)
    *iter=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-skippage")) == 0)
    *skippage=atoi(argv[i+1]);
  else if ((strcmp(argv[i],"-wem")) == 0)
    ew[0]=(float)atof(argv[i+1]);
  else if ((strcmp(argv[i],"-wed")) == 0)
    ew[1]=(float)atof(argv[i+1]);
  else if ((strcmp(argv[i],"-wli")) == 0)
    ew[2]=(float)atof(argv[i+1]);
  else if ((strcmp(argv[i],"-wco")) == 0)
    ew[3]=(float)atof(argv[i+1]);
  else if ((strcmp(argv[i],"-wcu")) == 0)
    ew[4]=(float)atof(argv[i+1]);
  else
    {
    fprintf(stdout,"Unknown argument:  %s\n",argv[i]);
    exit();
    }
  }

if (ew[0] > 0.0)
  {
  if ((strcmp(EMIFilename,"")) == 0)
    {
    fprintf(stdout,"You must supply an EMI file, or set -wem 0.0\n");
    exit();
    }
  ReadImage(EMIFilename,*NRows,*NCols,EMI);
  }
if (ew[1] > 0.0)
  {
  if ((strcmp(EDIFilename,"")) == 0)
    {
    fprintf(stdout,"You must supply an EDI file, or set -wed 0.0\n");
    exit();
    }
  ReadImage(EDIFilename,*NRows,*NCols,EDI);
  }
if ((strcmp(ContourFilename,"")) == 0)
  {
  fprintf(stdout,"You must supply a contour file\n");
  exit();
  }
ReadContour(ContourFilename,TP,x,y,*skippage);
}





ReadImage(filename,nrows,ncols,image)

char		*filename;
int		nrows,ncols;
unsigned char	**image;

{
FILE		*fpt;

if (nrows < 1  ||  ncols < 1)
  {
  fprintf(stdout,"Bad image size, or size not given.\n");
  exit();
  }
if ((*image=(unsigned char *)calloc(nrows*ncols,sizeof(unsigned char))) == 0)
  {
  fprintf(stdout,"Not enough memory.\n");
  exit();
  }
if ((fpt=fopen(filename,"r")) == 0)
  {
  fprintf(stdout,"File `%s' not found.\n",filename);
  exit();
  }
fread(*image,1,nrows*ncols,fpt);
fclose(fpt);
}




ReadContour(filename,tp,x,y,skip)

char		*filename;
int		*tp,**x,**y,skip;

{
FILE		*fpt;
int		i,rtp,a,b;

if ((fpt=fopen(filename,"r")) == 0)
  {
  fprintf(stdout,"File `%s' not found.\n",filename);
  exit();
  }
if ((fscanf(fpt,"%d",&rtp)) != 1)
  {
  fprintf(stdout,"Problem reading contour file.\n");
  exit();
  }
if (skip == 1)
  *tp=rtp;
else
  *tp=1+((rtp-1)/skip);
*x=(int *)calloc(*tp,sizeof(int));
*y=(int *)calloc(*tp,sizeof(int));
for (i=0; i<rtp; i=i+1+skip)
  if ((fscanf(fpt,"%d %d",&a,&b)) == 0)
    {
    fprintf(stdout,"Problem reading contour file.\n");
    exit();
    }
  else
    {
    (*x)[i]=a;
    (*y)[i]=b;
    }
}





PrintHelp()

{
fprintf(stdout,
"Usage: snakes [file options] {[algorithm options] [energy options]}\n");
fprintf(stdout,"File options:\n");
fprintf(stdout,"  -emi filename		- edge magnitude image\n");
fprintf(stdout,"  -edi filename		- edge direction image\n");
fprintf(stdout,"  -x size		- number of columns in image\n");
fprintf(stdout,"  -y size		- number of rows in image\n\n");
fprintf(stdout,"  -c filename		- contour to process; format below\n");
fprintf(stdout,"  -skippage n		- process every nth point of contour (default is 1)\n");
fprintf(stdout,"  -o filename		- output contour filename (default is `snakes.out')\n\n");
fprintf(stdout,"Algorithm options:\n");
fprintf(stdout,"  -ws size		- neighborhood window size NxN, where N=2*size+1\n");
fprintf(stdout,"			  (default is 2 <==> 5x5)\n");
fprintf(stdout,"  -nws size		- normalization window size, for spatially related\n");
fprintf(stdout,"			  energy terms; 0 (default) means same size as `-ws'\n");
fprintf(stdout,"  -dir control		- specifies dir to process pts of contour; 0 (default)\n");
fprintf(stdout,"			  means forward all iterations; other values cause\n");
fprintf(stdout,"			  toggle of dir on given value, starting forward\n");
fprintf(stdout,"			  (positive) or backward (negative)\n");
fprintf(stdout,"  -iter n		- process contour n iterations (default is 10)\n\n");
fprintf(stdout,"Energy options:\n");
fprintf(stdout,"  -wem weight		-set edge magnitude weight (default is 1.2)\n");
fprintf(stdout,"  -wed weight		-set edge direction weight (default is 0.0)\n");
fprintf(stdout,"  -wli weight		-set linearality weight (default is 1.0)\n");
fprintf(stdout,"  -wco weight		-set continuity weight (default is 1.0)\n");
fprintf(stdout,"  -wcu weight		-set curvature weight (default is 0.0)\n\n");
fprintf(stdout,"Contour file format:\n");
fprintf(stdout,"  ASCII format.  First line:  number of points in the contour.\n");
fprintf(stdout,"  Following lines:  `X Y' coordinates of contour points, one to a line.\n\n");
fprintf(stdout,"NOTES:\n");
fprintf(stdout,"  (1) You must either supply an EMI file, or set `-wem 0.0'.\n");
fprintf(stdout,"  (2) If you set `-wed', you must supply an EDI file.\n");
fprintf(stdout,"  (3) Weights are relative to each other.\n");
}


